#pragma once
#pragma once
#include "Settings.h"
#include "SMBios.h"
#include <vector>
#include "Hardware.h"
#include "IComputer.h"
#include "dll_macro.h"
class Visitor;
struct innerComputerInterface;
/**
  * ȻIͷֻΪ˺C#ౣһ£ǳ
  * ӦñֶʵֻԴӱлȡ
  */
class DLL_API IComputer {
public:

    //ȷҲinnerComputerInterfaceʵֵģҪҵ͸ñˡ
    //ӦñֶʵֻԴӱлȡ
    IComputer(std::shared_ptr<innerComputerInterface>  inner);

    virtual bool operator==(const IComputer& other) const;

    bool isNull() const;

    virtual ~IComputer();

    virtual std::vector<Hardware> getHardware();

    virtual bool isBatteryEnabled();

    virtual bool isControllerEnabled();

    virtual bool isCpuEnabled();

    virtual bool isGpuEnabled();

    virtual bool isMemoryEnabled();

    virtual bool isMotherboardEnabled();

    virtual bool isNetworkEnabled();

    virtual bool isPsuEnabled();

    virtual bool isStorageEnabled();

    virtual std::string GetReport();

    virtual void Accept(Visitor* visitor);
    virtual void Traverse(Visitor* visitor);

protected:
    std::shared_ptr<innerComputerInterface>  inner;

    //ӦⲿinnergettersetterǷ㶨ͬ
    void setIComputerInner(std::shared_ptr<innerComputerInterface>  inner) {
        this->inner = inner;
    }
    std::shared_ptr<innerComputerInterface> getIComputerInner() const {
        return inner;
    }
};
